/*
Copyright (C) 2006 Evan Teran
                   eteran@alum.rit.edu

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef BOOKMARKS_20061122_H_
#define BOOKMARKS_20061122_H_

#include "DebuggerPluginInterface.h"
#include "Types.h"

class QMenu;
class QListWidget;
class QPushButton;
class QListWidgetItem;
class QSignalMapper;
#include <QList>

class Bookmarks : public QObject, public DebuggerPluginInterface {
	Q_OBJECT
	Q_INTERFACES(DebuggerPluginInterface)
	Q_CLASSINFO("Author", "Evan Teran")
	Q_CLASSINFO("URL", "http://www.codef00.com")

public:
	Bookmarks();
	
public:
	virtual QMenu *menu(QWidget *parent = 0);
	
public slots:
	void doMenu();
	
	void add();
	void del();
	void clear();
	void itemDoubleClicked(QListWidgetItem *);

private slots:
	void doShortcut(int index);
	
signals:
	void signalShortcut(int);

private:
	QMenu					*m_Menu;
	QPushButton				*m_ButtonAdd;
	QPushButton				*m_ButtonDel;
	QPushButton				*m_ButtonClear;
	QListWidget				*m_List;
	QSignalMapper			*m_SignalMapper;
	QList<edb::address_t>	m_Entries;
};

#endif
